<!DOCTYPE HTML>
{# ------------------------------------------------------------------------------------ #}
{#  VARIABLES                                                                           #}
{# ------------------------------------------------------------------------------------ #}
{%- set dc = ctx|to_context_obj -%}
{%- import "src/_ifb_dsw_globals.j2" as ifb_dsw_globals with context -%}
{# ------------------------------------------------------------------------------------ #}
{#  TAGS, REFERENCES, and EXPERTS MACROS                                                 #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderResourcePageReferences(question) -%}
  {% set refs = [] %}
  {% for ref in question.resource_page_references %}
    {% if ref.resource_page_uuid and ref.resource_page and ref.resource_page.collection %}
      {% do refs.append({
        'ref_uuid': ref.uuid,
        'uuid': ref.resource_page_uuid,
        'collection_title': ref.resource_page.collection.title,
        'title': ref.resource_page.title,
      }) %}
    {% endif %}
  {% endfor %}
  {% if refs|length > 0 %}
    <div class="references references-resourcepage">
      <svg aria-hidden="true" data-prefix="fas" data-icon="book" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-book fa-w-14 fa-2x"><path fill="currentColor" d="M448 360V24c0-13.3-10.7-24-24-24H96C43 0 0 43 0 96v320c0 53 43 96 96 96h328c13.3 0 24-10.7 24-24v-16c0-7.5-3.5-14.3-8.9-18.7-4.2-15.4-4.2-59.3 0-74.7 5.4-4.3 8.9-11.1 8.9-18.6zM128 134c0-3.3 2.7-6 6-6h212c3.3 0 6 2.7 6 6v20c0 3.3-2.7 6-6 6H134c-3.3 0-6-2.7-6-6v-20zm0 64c0-3.3 2.7-6 6-6h212c3.3 0 6 2.7 6 6v20c0 3.3-2.7 6-6 6H134c-3.3 0-6-2.7-6-6v-20zm253.4 250H96c-17.7 0-32-14.3-32-32 0-17.6 14.4-32 32-32h285.4c-1.9 17.1-1.9 46.9 0 64z" class=""></path></svg>
      <span><b>Resource Pages:</b></span>
      {% for ref in refs %}
        <a id="{{ref.ref_uuid}}" class="reference resourcepage-link" href="#resource-page-{{ ref.uuid }}"><i>{{ ref.collection_title }} - {{ ref.title }}</i></a>
      {% endfor %}Format:
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderURLReferences(question) -%}
  {% set refs = [] %}
  {% for ref in question.url_references %}
    {% if ref.label and ref.url %}
      {% do refs.append({
        'uuid': ref.uuid,
        'label': ref.label,
        'url': ref.url,
      }) %}
    {% endif %}
  {% endfor %}
  {% if refs|length > 0 %}
    <div class="references references-url" >
      <svg aria-hidden="true" data-prefix="far" data-icon="external-link" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512" class="svg-inline--fa fa-external-link fa-w-18 fa-2x"><path fill="currentColor" d="M576 14.4l-.174 163.2c0 7.953-6.447 14.4-14.4 14.4H528.12c-8.067 0-14.56-6.626-14.397-14.691l2.717-73.627-2.062-2.062-278.863 278.865c-4.686 4.686-12.284 4.686-16.971 0l-23.029-23.029c-4.686-4.686-4.686-12.284 0-16.971L474.379 61.621l-2.062-2.062-73.626 2.717C390.626 62.44 384 55.946 384 47.879V14.574c0-7.953 6.447-14.4 14.4-14.4L561.6 0c7.953 0 14.4 6.447 14.4 14.4zM427.515 233.74l-24 24a12.002 12.002 0 0 0-3.515 8.485V458a6 6 0 0 1-6 6H54a6 6 0 0 1-6-6V118a6 6 0 0 1 6-6h301.976c10.691 0 16.045-12.926 8.485-20.485l-24-24A12.002 12.002 0 0 0 331.976 64H48C21.49 64 0 85.49 0 112v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V242.225c0-10.691-12.926-16.045-20.485-8.485z" class=""></path></svg>
      <b>External Links:</b>
      {% for ref in refs %}
        <a id="{{ref.uuid}}" class="reference url-link" href="{{ref.url}}" target="_blank"><i>{{ref.label}}</i></a>
      {% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderExperts(question) -%}
  {% set experts = [] %}
  {% for expert in question.experts %}
    {% if expert.name and expert.email %}
      {% do experts.append({
        'uuid': expert.uuid,
        'email': expert.email,
        'name': expert.name,
      }) %}
    {% endif %}
  {% endfor %}
  {% if experts|length > 0 %}
    <div class="experts">
      <svg aria-hidden="true" data-prefix="far" data-icon="address-book" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-address-book fa-w-14 fa-2x"><path fill="currentColor" d="M436 160c6.6 0 12-5.4 12-12v-40c0-6.6-5.4-12-12-12h-20V48c0-26.5-21.5-48-48-48H48C21.5 0 0 21.5 0 48v416c0 26.5 21.5 48 48 48h320c26.5 0 48-21.5 48-48v-48h20c6.6 0 12-5.4 12-12v-40c0-6.6-5.4-12-12-12h-20v-64h20c6.6 0 12-5.4 12-12v-40c0-6.6-5.4-12-12-12h-20v-64h20zm-68 304H48V48h320v416zM208 256c35.3 0 64-28.7 64-64s-28.7-64-64-64-64 28.7-64 64 28.7 64 64 64zm-89.6 128h179.2c12.4 0 22.4-8.6 22.4-19.2v-19.2c0-31.8-30.1-57.6-67.2-57.6-10.8 0-18.7 8-44.8 8-26.9 0-33.4-8-44.8-8-37.1 0-67.2 25.8-67.2 57.6v19.2c0 10.6 10 19.2 22.4 19.2z" class=""></path></svg>
      <b>Experts:</b>
      {% for expert in experts %}
        <i class="expert" id="{{expert.uuid}}">{{expert.name}} (<a href="mailto:{{expert.email}}">{{expert.email}}</a>)</i>
      {% endfor %}
    </div>
  {% endif %}
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  ANSWERS MACROS                                                                      #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderAnswerValue(question, reply, path, humanIdentifier) -%}
  <div class="answer-block answer-simple" id="{{path}}" data-path="{{path}}" data-type="answer">
    <p class="answer">
 {#     <svg aria-hidden="true" data-prefix="fas" data-icon="check" class="svg-inline--fa fa-check fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg> #}
      {% if reply is of_type("StringReply") %}
        <span style="color:blue"><b>{{reply.value}}</b></span>
      {% elif reply.is_integration %}
        <span style="color:blue"><b>{{reply.value|markdown}}</b></span>
      {% else %}
        <span style="color:blue"><b>{{reply.value}}</b></span>
      {% endif %}
    </p>
  </div>
{%- endmacro -%}
{%- macro renderAnswerOption(globals, question, reply, path, humanIdentifier) -%}

  {%- if reply -%}
    {%- set answer = reply.answer -%}
  {%- else -%}
    {%- set answer = none  -%}
  {%- endif -%}

  {%- for option in question.answers -%}
    {% set hi = question.answers.index(option) %}
    {% set path = path ~ "." ~ option.uuid %}
{#    {% set humanIdentifier = humanIdentifier ~ "." ~ hi|of_alphabet %}  #}
    {% set humanIdentifier = hi|of_alphabet %}
    {%- if reply and option.label == answer.label -%}
      <div class="answer-block answer-option" id="{{path}}" data-path="{{path}}" data-uuid="{{answer.uuid}}" data-type="answer">
        <p class="answer">
          <svg aria-hidden="true" data-prefix="fas" data-icon="check" class="svg-inline--fa fa-check fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg>
          <span>{{ hi|of_alphabet }}. <span style="color:blue"><b>{{answer.label}}</b></span></span>
        </p>
        {% if answer.advice and globals.with_all_text %}
          <div class="advice">
            {{answer.advice|markdown}}
          </div>
        {% endif %}
        {% if answer.followups|length > 0 %}
          <div class="answer-item" id="" data-path="{{path}}">
            <div class="followups">
              {% set hiPrefix = humanIdentifier ~ "." %}
              {% for question in answer.followups %}
                {% set x = loop.index %}
                {{ renderQuestion(globals, question, path, hiPrefix ~ x) }}
              {% endfor %}
            </div>
          </div>
        {% endif %}
      </div>
    {% elif not globals.replies_only %}
      <div class="answer-block answer-option" id="{{path}}" data-path="{{path}}" data-uuid="{{answer.uuid}}" data-type="answer">
        <p class="answer">
          <svg aria-hidden="true" data-prefix="fas" data-icon="times" class="svg-inline--fa fa-check fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"></path></svg>
          <span>{{ hi|of_alphabet }}. {{option.label}}</span>
        </p>
        {% if option.advice and globals.with_all_text %}
          <div class="advice">
            {{option.advice|markdown}}
          </div>
        {% endif %}
        {% if option.followups|length > 0 %}
          <div class="answer-item" id="" data-path="{{path}}">
            <div class="followups">
            {% set hiPrefix = humanIdentifier ~ "." %}
            {% for question in option.followups %}
              {% set x = loop.index %}
              {{ renderQuestion(globals, question, path, hiPrefix ~ x) }}
            {% endfor %}
            </div>
          </div>
        {% endif %}
      </div>
    {% endif %}
  {% endfor %}
{%- endmacro -%}
{%- macro renderAnswerList(globals, question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div class="answer-block answer-items" id="{{path}}" data-path="{{path}}" data-type="answer">
      {% set itemPathPrefix = path ~ "." %}
      {% set hiPrefix = humanIdentifier ~ "." %}
      {% for itemUuid in reply.items %}
        <h4>----</h4>
        {% set itemPath = itemPathPrefix ~ itemUuid %}
 {#       {% set itemHumanIdenfifier = hiPrefix ~ (loop.index - 1)|of_alphabet %} #}
        {% set itemHumanIdenfifier = (loop.index - 1)|of_alphabet %}
        <div class="answer-item" id="item-{{ question.uuid }}-{{itemUuid}}" data-path="{{itemPath}}">
          <div class="followups">
            {% for question in question.followups %}
              {% set x = loop.index %}
              {{ renderQuestion(globals, question, itemPath, itemHumanIdenfifier ~ "." ~ x) }}
            {% endfor %}
          </div>
        </div>
      {% endfor %}
    </div>
  {% elif not globals.replies_only %}
    <div class="answer-block answer-items" id="{{path}}" data-path="{{path}}" data-type="answer">
      {% set itemPathPrefix = path ~ "." %}
      {% set hiPrefix = humanIdentifier ~ "." %}
      {% set itemUuid = "00000000-0000-0000-0000-000000000000" %}
      {% set itemPath = itemPathPrefix ~ itemUuid %}
{#      {% set itemHumanIdenfifier = hiPrefix ~ (0)|of_alphabet %} #}
      {% set itemHumanIdenfifier = (0)|of_alphabet %}
      <div class="answer-item" id="item-{{ question.uuid }}-{{itemUuid}}" data-path="{{itemPath}}">
        <div class="followups">
          {% for question in question.followups %}
            {% set x = loop.index %}
            {{ renderQuestion(globals, question, itemPath, itemHumanIdenfifier ~ "." ~ x) }}
          {% endfor %}
        </div>
      </div>
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderAnswerChoiceList(globals, question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div class="answer-block answer-items" id="{{path}}" data-path="{{path}}" data-type="answer">
      <div class="choices-list">
        {% for choice in question.choices %}
          {%- if choice in reply.choices %}
            <div class="choice choice-selected">
              <svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="check-square" class="svg-inline--fa fa-check-square fa-w-14" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M400 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V80c0-26.51-21.49-48-48-48zm0 400H48V80h352v352zm-35.864-241.724L191.547 361.48c-4.705 4.667-12.303 4.637-16.97-.068l-90.781-91.516c-4.667-4.705-4.637-12.303.069-16.971l22.719-22.536c4.705-4.667 12.303-4.637 16.97.069l59.792 60.277 141.352-140.216c4.705-4.667 12.303-4.637 16.97.068l22.536 22.718c4.667 4.706 4.637 12.304-.068 16.971z"></path></svg>
              <span style="color:blue"><b>{{ choice.label }}</b></span>
            </div>
          {%- else %}
            <div class="choice choice-unselected">
              <svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="square" class="svg-inline--fa fa-square fa-w-14" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm-6 400H54c-3.3 0-6-2.7-6-6V86c0-3.3 2.7-6 6-6h340c3.3 0 6 2.7 6 6v340c0 3.3-2.7 6-6 6z"></path></svg>
              {{ choice.label }}
            </div>
          {%- endif %}
        {% endfor %}
      </div>
    </div>
  {% elif not globals.replies_only %}
    <div class="answer-block answer-items" id="{{path}}" data-path="{{path}}" data-type="answer">
      <div class="choices-list">
        {% for choice in question.choices %}
          <div class="choice choice-unselected">
            <svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="square" class="svg-inline--fa fa-square fa-w-14" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm-6 400H54c-3.3 0-6-2.7-6-6V86c0-3.3 2.7-6 6-6h340c3.3 0 6 2.7 6 6v340c0 3.3-2.7 6-6 6z"></path></svg>
              {{ choice.label }}
            </div>
        {% endfor %}
      </div>
    </div>
  {% endif %}
{%- endmacro -%}
{%- macro renderAnswerItemSelect(question, reply, path, humanIdentifier) -%}
  {% if reply %}
    <div class="answer-block answer-select" id="{{path}}" data-path="{{path}}" data-type="answer">
      <p class="answer">
        <svg aria-hidden="true" data-prefix="fas" data-icon="check" class="svg-inline--fa fa-check fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"></path></svg>
        <a href="#item-{{ question.list_question_uuid }}-{{ reply.item_uuid }}">{{ reply.item_title }}</a>
      </p>
    </div>
  {% endif %}
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  QUESTION MACROS                                                                     #}
{# ------------------------------------------------------------------------------------ #}
{%- macro questionClasses(question) -%}
  "question {{ "required" if question.is_required else "optional"}} {{  ("phase-" ~ question.required_phase.order) if question.required_phase else "phase-none" }}"
{%- endmacro -%}
{%- macro renderQuestionExtras(question) -%}
  <div class="extra-data">
    {# Question - References - Resource Page References #}
    {{ renderResourcePageReferences(question) }}
    {# Question - References - URL References #}
    {{ renderURLReferences(question) }}
    {# Question - Experts #}
    {{ renderExperts(question) }}
  </div>
{%- endmacro -%}
{%- macro renderQuestionReply(globals, question, path, humanIdentifier) -%}
  {# Question - Answers #}
  {% set reply = question.replies.get(path) %}
  {% if reply and reply.value and (globals.with_replies or globals.replies_only) %}
    {% if question is of_type("ValueQuestion") and reply is of_type("StringReply") %}
      {{ renderAnswerValue(question, reply, path, humanIdentifier) }}
    {% elif question is of_type("OptionsQuestion") and reply is of_type("AnswerReply") %}
      {{ renderAnswerOption(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("ListQuestion") and reply is of_type("ItemListReply") %}
      {{ renderAnswerList(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("IntegrationQuestion") and reply is of_type("IntegrationReply") %}
      {{ renderAnswerValue(question, reply, path, humanIdentifier) }}
    {% elif question is of_type("MultiChoiceQuestion") and reply is of_type("MultiChoiceReply") %}
      {{ renderAnswerChoiceList(globals, question, reply, path, humanIdentifier) }}
    {% elif question is of_type("ItemSelectQuestion") and reply is of_type("ItemSelectReply") %}
      {{ renderAnswerItemSelect(question, reply, path, humanIdentifier) }}
    {% endif %}
  {% elif not globals.replies_only %}
    {% if question is of_type("OptionsQuestion") %}
      {{ renderAnswerOption(globals, question, none, path, humanIdentifier) }}
    {% elif question is of_type("ListQuestion") %}
      {{ renderAnswerList(globals, question, none, path, humanIdentifier) }}
    {% elif question is of_type("MultiChoiceQuestion") %}
      {{ renderAnswerChoiceList(globals, question, none, path, humanIdentifier) }}
    {% endif %}
  {% endif %}
{%- endmacro -%}
{%- macro renderQuestion(globals, question, path, humanIdentifier) -%}
  {% set path = path ~ "." ~ question.uuid %}

  {% set reply = question.replies.get(path) %}
  {% if reply or (not reply and not globals.replies_only) %}
    <div class={{questionClasses(question)}} id="{{path}}" data-uuid="{{question.uuid}}" data-type="question">
      <div class="question-header">
        <h4 class="title">
          <strong class="human-identifier">{{humanIdentifier}}</strong>
          {{question.title}}
        </h4>
        
        {#    {% if question.tags|length > 0 %}
        <div class="tags">
          {% for tag in question.tags %}
            <span class="tag" style="background-color:{{tag.color}}">{{tag.name}}</span>
          {% endfor %}
        </div>
      {% endif %}
      #}
      </div>

      {% if globals.with_all_text %}
        <div class="text">
          {{question.text|markdown}}
        </div>

        {{ renderQuestionExtras(question) }}
      {% endif %}
      
      {{ renderQuestionReply(globals, question, path, humanIdentifier) }}
    </div>
  {% endif %}
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  CHAPTER MACROS                                                                      #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderChapter(globals, chapter, humanIdentifier) -%}
      <section class="chapter" id="{{chapter.uuid}}" data-uuid="{{chapter.uuid}}" data-type="chapter">
        <h2 class="title">{{humanIdentifier|roman}}. {{chapter.title}}</h2>

        {% if globals.with_all_text %}
          <p class="text-light">{{chapter.text|markdown}}</p>
        {% endif %}
        
        <section class="questions">
          {% for question in chapter.questions %}
            {{ renderQuestion(globals, question, chapter.uuid, loop.index) }}
          {% endfor %}
        </section>
      </section>
{%- endmacro -%}
{# ------------------------------------------------------------------------------------ #}
{#  HTML LAYOUT                                                                         #}
{# ------------------------------------------------------------------------------------ #}
{%- macro renderFrontPage() -%}
  <header>
    <h1>{{dc.qtn.name}}</h1>

    <table class="dmp-data">
      <tr>
        <th>Organization</th>
        <td>{{dc.org.name}}</td>
      </tr>
      {% if dc.qtn.created_by %}
      <tr>
        <th>Created by</th>
        <td>{{dc.qtn.created_by.first_name}} {{dc.qtn.created_by.last_name}} (<a href="mailto:{{dc.qtn.created_by.email}}">{{dc.qtn.created_by.email}}</a>)</td>
      </tr>
      {% endif %}
      <tr>
        <th>Based on</th>
        <td>{{dc.pkg.name}}, {{dc.pkg.version}} (<span class="package-id"><span class="organization-id">{{dc.pkg.org_id}}</span>:<span class="km-id">{{dc.pkg.km_id}}</span>:<span class="version">{{dc.pkg.version}}</span></span>)</td>
      </tr>
      {% for version in dc.qtn.versions if version.uuid == dc.qtn.version %}
      <tr>
        <th>Version</th>
        <td>{{version.name}} ({{ version.created_at|datetime_format("%d %b %Y %H:%M:%S") }} UTC)</td>
      </tr>
      {% endfor %}
      {% if dc.current_phase %}
      <tr>
        <th>Project Phase</th>
        <td>{{dc.current_phase.title}}</td>
      </tr>
      {% endif %}
      {% if dc.qtn.project_tags|length > 0 %}
      <tr>
        <th>Project Tags</th>
        <td class="tags-row">{% for tag in dc.qtn.project_tags %}<span class="tag project-tag">{{ tag }}</span> {% endfor %}</td>
      </tr>
      {% endif %}
      {% if dc.qtn.description %}
      <tr>
        <th>Description</th>
        <td>{{ dc.qtn.description }}</td>
      </tr>
      {% endif %}
      <tr>
        <th>Created at</th>
        <td>{{ dc.doc.created_at|datetime_format("%d %b %Y") }}</td>
      </tr>
    </table>
    <p class="tool-info">
      Report generated by {{ ifb_dsw_globals.fullName }} &lt;<a href="{{ ifb_dsw_globals.linkUrl }}" target="_blank">{{ ifb_dsw_globals.linkUrl }}</a>&gt;
      {{ ifb_dsw_globals.image }}
    </p>
  </header>
{%- endmacro -%}



{# here I'll move all original macros from DSW Questionnaire Report #}
{# that are not used in the context of IFB-lite #}
{# I keep them here just in case they might become handy #}




{%- macro renderContent() -%}
  <main>
    <section class="total-report">
      <h2>Summary Report</h2>
      {{ renderReport(dc.report.total_report) }}

      {% if dc.qtn.versions|length > 0 %}
      <h2>History of Versions</h2>
      {{ renderVersionsOverview() }}
      {% endif %}
    </section>
    {% for chapter in dc.km.chapters %}
      {{ renderChapter(chapter, loop.index) }}
    {% else %}
      <p class="text-light">No chapters</p>
    {% endfor %}
    <section class="resource-collections">
    {% if dc.km.resource_collections|length > 0 %}
      <h2>Additional Resources</h2>
    {% endif %}
    {% for resource_collection in dc.km.resource_collections %}
      {{ renderResourceCollection(resource_collection, (loop.index-1)|of_alphabet|upper) }}
    {% endfor %}
    </section>
  </main>
{%- endmacro -%}
{%- macro renderVersionsOverview() -%}
  <div id="versions">
    <table>
      <thead>
        <tr>
          <th>Version</th>
          <th>Date</th>
          <th>Changes</th>
        </tr>
      <thead>
      <tbody>
        {% for version in dc.qtn.versions|reverse %}
          <tr>
            <td class="version-name">{{ version.name }}</td>
            <td class="version-date">{{ version.created_at|datetime_format("%d %b %Y") }}</td>
            <td class="version-changes">{{ version.description }}</td>
          </tr>
        {% else %}
          <tr>
            <td colspan="3" class="no-versions">There are no named versions</tr>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
{%- endmacro -%}
{%- macro renderResourceCollection(collection, humanIdentifier) -%}
  <div id="resource-collection-{{collection.uuid}}" class="resource-collection">
    <h3>{{ humanIdentifier }}. {{ collection.title }}</h3>

    {%- for page in collection.pages -%}
    <div id="resource-page-{{page.uuid}}" class="resource-page">
      <h4>{{ humanIdentifier }}.{{ loop.index }}. {{ page.title }}</h4>
      <div class="resource-page-content">
        {{ page.content|markdown }}
      </div>
    </div>
    {%- endfor -%}
  </div>
{%- endmacro -%}
{%- macro renderReport(report) -%}
  <section class="report">
    <h3 class="title">Summary</h3>
    <div class="indications">
      <table>
        <tbody>
          {% for item in report.indications %}
            <tr>
              <td class="table-label">Answered {% if item.is_for_phase %}(current phase){% endif %}</td>
              <td>{{item.answered}} / {{item.total}} </td>
              <td class="progress-cell">
                <div class="progress">
                  <div class="progress-fill" style="width:{{100 * item.percentage}}%">
                  </div>
                </div>
              </td>
            </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    {% if report.metrics|length > 0 %}
    <div class="metrics">
        <table>
          <thead><tr><th>Metric</th><th colspan="2">Score</th></tr></thead>
          <tbody>
            {% for item in report.metrics %}
              <tr>
                <td class="table-label">
                  {{item.metric.title}}
                </td>
                <td>{{ "%.2f"|format(item.measure) }}</td>
                <td class="progress-cell">
                  <div class="progress">
                    <div class="progress-fill bg-value-{{(item.measure * 10)|int}}0" style="width:{{100 * item.measure}}%">
                    </div>
                  </div>
                </td>
              </tr>
            {% endfor %}
          </tbody>
        </table>
    </div>
    {% endif %}
  </section>
{%- endmacro -%}
